# Fork of React JSON Editor (AJRM)

This repository is a fork of the [React JSON Editor (AJRM)](https://github.com/AndrewRedican/react-json-editor-ajrm) project by [Andrew Redican](https://github.com/AndrewRedican). The original project aimed to provide a versatile JSON editor for React applications. This fork has been created to address specific issues or improvements.

## Overview

[React JSON Editor (AJRM)](https://github.com/AndrewRedican/react-json-editor-ajrm) is a flexible and customizable JSON editor for React applications. It allows users to visualize and edit JSON data with a user-friendly interface.

## Changes in this Fork

* **[Fix issue with the "nodeType" property]**: Currently, attempting to use the "nodeType" property in the JSON editor results in an error. This occurs because the library attempts to tokenize the content and incorrectly identifies it as a DOM element. Consequently, it tries to invoke a method called "cloneNode," which is present in the DOM but not in JSON objects. In this fork, we have addressed this issue by validating that the object possesses the "cloneNode" method. ![Alt Text](https://assets-stg.cto.ai/static/react-editor-evidence.png)


## License

This fork inherits the [MIT License](https://github.com/AndrewRedican/react-json-editor-ajrm/blob/HEAD/LICENSE.md) from the original project.

## Acknowledgments

* [Andrew Redican](https://github.com/AndrewRedican) - The original creator of React JSON Editor (AJRM).